
//=========================================Դ================================================//
//     LCDģ                AI8051U
//      VCC                  DC5V/3.3V      //Դ
//      GND                    GND          //Դ

//=======================================Һ߽==========================================//
//ģĬΪSPI
//     LCDģ                AI8051U    
//    	MOSI                   P15          //ҺSPIдź
//      MISO                   P16          //ҺSPIݶźţҪԲ
//      SCK                    P17          //ҺSPIʱź
//     LCD_CS                  P14          //ҺƬѡź

//=======================================Һ߽==========================================//
//     LCDģ 					      AI8051U 
//      LCD_BL                 P10          //ҺźţҪƣԲӣ
//      LCD_RS                 P11          //Һ/ź(DC)
//      RESET                  P47         	//Һλź
//=================================================================================================

#include "lcd.h"

//LCDҪ
_lcd_dev lcddev;

//ɫ,ɫ
u16 POINT_COLOR = 0x0000;
u16 BACK_COLOR = 0xFFFF;  
u16 DeviceCode;

//========================================================================
// : void LCD_WR_REG(u8 dat)		
// : LCDдһֽ
// : Ҫд
// : none
// ע: RSΪ͵ƽʱд
//========================================================================
void LCD_WR_REG(u8 dat)
{ 
   LCD_CS=0;     
	 LCD_RS=0;	  
   SPI_WriteByte(dat);
   LCD_CS=1;	
}

//========================================================================
// : void LCD_WR_DATA(u8 dat)	
// : LCDдһֽ
// : Ҫд
// : none
// ע: RSΪߵƽʱд
//========================================================================
void LCD_WR_DATA(u8 dat)
{
   LCD_CS=0;
	 LCD_RS=1;
   SPI_WriteByte(dat);
   LCD_CS=1;
}

//========================================================================
// : u8 LCD_RD_DATA(void)	
// : LCDȡһֽ
// : none
// : ȡ
// ע: none
//========================================================================
u8 LCD_RD_DATA(void)
{
	 u8 dat;
	 LCD_CS=0;
	 LCD_RS=1;
//	 SPI_SetSpeed(SPI1,0);
	 dat = SPI_WriteByte(0xFF);
//	 SPI_SetSpeed(SPI1,1);
	 LCD_CS=1;
	 return dat;
}

//========================================================================
// : void LCD_WriteReg(u8 LCD_Reg, u16 LCD_RegValue)
// : LCDָļĴRegдһValue
// : LCD_RegĴλ
//			 LCD_RegValueҪд
// : none
// ע: none
//========================================================================
void LCD_WriteReg(u8 LCD_Reg, u16 LCD_RegValue)
{	
	LCD_WR_REG(LCD_Reg);  
	LCD_WR_DATA(LCD_RegValue);	    		 
}	

//========================================================================
// : u8 LCD_ReadReg(u8 LCD_Reg)
// : ȡָĴ
// : LCD_RegĴλ
// : ȡ
// ע: none
//========================================================================
u8 LCD_ReadReg(u8 LCD_Reg)
{
	LCD_WR_REG(LCD_Reg);
  return LCD_RD_DATA();
}

//========================================================================
// : void LCD_WriteRAM_Prepare(void)
// : ׼LCDдGRAMͼȡ洢
// : none
// : none
// ע: none
//========================================================================
void LCD_WriteRAM_Prepare(void)
{
	LCD_WR_REG(lcddev.wramcmd);
}	 

//========================================================================
// : void LCD_ReadRAM_Prepare(void)
// : ׼LCDȡGRAMͼȡ洢
// : none
// : none
// ע: 
//========================================================================
void LCD_ReadRAM_Prepare(void)
{
	LCD_WR_REG(lcddev.rramcmd);
}	 

//========================================================================
// : void Lcd_WriteData_16Bit(u16 Dat)
// : LCDдһ16λ
// : Ҫд
// : none
// ע: none
//========================================================================
void Lcd_WriteData_16Bit(u16 dat)
{
	LCD_CS=0;
	LCD_RS=1;	
	SPI_WriteByte(dat>>8);
	SPI_WriteByte(dat);
	LCD_CS=1;
}

//========================================================================
// : u16 Lcd_ReadData_16Bit(void)
// : LCDȡһ16λ
// : none
// : ȡ
// ע: none
//========================================================================
u16 Lcd_ReadData_16Bit(void)
{
	u16 r,g;
	LCD_CS=0;
	LCD_RS=0;	  
	SPI_WriteByte(lcddev.rramcmd);
//	SPI_SetSpeed(SPI1,0);
	LCD_RS=1;
	SPI_WriteByte(0xFF);
	r = SPI_WriteByte(0xFF);
	g = SPI_WriteByte(0xFF);
//	SPI_SetSpeed(SPI1,1);
	LCD_CS=1;
	r<<=8;
	r|=g;
	return r;
}

//========================================================================
// : void LCD_DrawPoint(u16 x,u16 y)
// : ضصдݣɫ
// : xyĻ
// : none
// ע: none
//========================================================================
void LCD_DrawPoint(u16 x,u16 y)
{
	LCD_SetCursor(x,y);//ùλ 
	Lcd_WriteData_16Bit(POINT_COLOR); 	//ɫ
}

//========================================================================
// : u16 LCD_ReadPoint(u16 x,u16 y)
// : ضصȡݣɫ
// : xyĻ
// : 16λݣɫ
// ע: none
//========================================================================
u16 LCD_ReadPoint(u16 x,u16 y)
{
	u16 color;
	LCD_SetCursor(x,y);//ùλ 
	color = Lcd_ReadData_16Bit();
	return color;
}

//========================================================================
// : void LCD_Clear(u16 Color)
// : ȫˢΪָɫ
// : Ҫˢµɫ
// : none
// ע: none
//========================================================================
void LCD_Clear(u16 Color)
{
  unsigned int i,m;  
	LCD_SetWindows(0,0,lcddev.width-1,lcddev.height-1);   
	LCD_CS=0;
	LCD_RS=1;
	for(i=0;i<lcddev.height;i++)
	{
    for(m=0;m<lcddev.width;m++)
    {	
			SPI_WriteByte(Color>>8);
			SPI_WriteByte(Color);
		}
	}
	 LCD_CS=1;
} 

//========================================================================
// : void LCD_IO_Init(void)		
// : ʼSPId IO
// : none
// : none
// ע: ģʽ
//========================================================================
void LCD_IO_Init(void)
{
	P1M0 |= 0x13;		//BL/RS/CS
	P1M1 &= ~0x13; 
	P4M0 |= 0x80; 	//RST
	P4M1 &= ~0x80;
	
	P1PU |= 0x13;		//
	P4PU |=	0x80;
	
	LCD_CS=1;
	LCD_BL=1;
	LCD_RS=1;
	LCD_RST=1;
}

//========================================================================
// : void LCD_RESET(void)		
// : LCD
// : none
// : none
// ע: none
//========================================================================
void LCD_RESET(void)
{
	LCD_RST=0;
	delay_ms(100);	
	LCD_RST=1;
	delay_ms(50);
}

//========================================================================
// : void LCD_Init(void)
// : λLCD
// : none
// : none
// ע: none
//========================================================================
void LCD_Init(void)
{
	SPI_Init();				//ӲSPIʼ
	LCD_IO_Init();		//LCD IOʼ
 	LCD_RESET(); 			//LCD λ
	
	/****	ST7796S IPSʼ	****/	
	LCD_WR_REG(0x11);     

	delay_ms(120);

	LCD_WR_REG(0x36);     // Memory Data Access Control MY,MX~~
	LCD_WR_DATA(0x48);   

	LCD_WR_REG(0x3A);     
	LCD_WR_DATA(0x55);   //LCD_WR_DATA(0x66);

	LCD_WR_REG(0xF0);     // Command Set Control
	LCD_WR_DATA(0xC3);   

	LCD_WR_REG(0xF0);     
	LCD_WR_DATA(0x96);   

	LCD_WR_REG(0xB4);     
	LCD_WR_DATA(0x01);   

	LCD_WR_REG(0xB7);     
	LCD_WR_DATA(0xC6);   

	//LCD_WR_REG(0xB9);     
	//LCD_WR_DATA(0x02);
	//LCD_WR_DATA(0xE0);

	LCD_WR_REG(0xC0);     
	LCD_WR_DATA(0x80);   
	LCD_WR_DATA(0x45);   

	LCD_WR_REG(0xC1);     
	LCD_WR_DATA(0x13);   //18  //00

	LCD_WR_REG(0xC2);     
	LCD_WR_DATA(0xA7);   

	LCD_WR_REG(0xC5);     
	LCD_WR_DATA(0x0A);   

	LCD_WR_REG(0xE8);     
	LCD_WR_DATA(0x40);
	LCD_WR_DATA(0x8A);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x00);
	LCD_WR_DATA(0x29);
	LCD_WR_DATA(0x19);
	LCD_WR_DATA(0xA5);
	LCD_WR_DATA(0x33);

	LCD_WR_REG(0xE0);
	LCD_WR_DATA(0xD0);
	LCD_WR_DATA(0x08);
	LCD_WR_DATA(0x0F);
	LCD_WR_DATA(0x06);
	LCD_WR_DATA(0x06);
	LCD_WR_DATA(0x33);
	LCD_WR_DATA(0x30);
	LCD_WR_DATA(0x33);
	LCD_WR_DATA(0x47);
	LCD_WR_DATA(0x17);
	LCD_WR_DATA(0x13);
	LCD_WR_DATA(0x13);
	LCD_WR_DATA(0x2B);
	LCD_WR_DATA(0x31);

	LCD_WR_REG(0xE1);
	LCD_WR_DATA(0xD0);
	LCD_WR_DATA(0x0A);
	LCD_WR_DATA(0x11);
	LCD_WR_DATA(0x0B);
	LCD_WR_DATA(0x09);
	LCD_WR_DATA(0x07);
	LCD_WR_DATA(0x2F);
	LCD_WR_DATA(0x33);
	LCD_WR_DATA(0x47);
	LCD_WR_DATA(0x38);
	LCD_WR_DATA(0x15);
	LCD_WR_DATA(0x16);
	LCD_WR_DATA(0x2C);
	LCD_WR_DATA(0x32);
	 

	LCD_WR_REG(0xF0);     
	LCD_WR_DATA(0x3C);   

	LCD_WR_REG(0xF0);     
	LCD_WR_DATA(0x69);   

	delay_ms(120);                

	LCD_WR_REG(0x20);     

	LCD_WR_REG(0x29); 

  LCD_direction(0);//LCDʾ 
	LCD_Clear(RED);//ȫɫ
	
	LCD_BL=1;
	
	UART1_printf("LCD\n");
}

//========================================================================
// : void LCD_SetWindows(u16 xStar, u16 yStar,u16 xEnd,u16 yEnd)
// : ʾλ
// : ֹͣxy
// : none
// ע: none
//========================================================================
void LCD_SetWindows(u16 xStar, u16 yStar,u16 xEnd,u16 yEnd)
{	
	LCD_WR_REG(lcddev.setxcmd);	
	LCD_WR_DATA(xStar>>8);
	LCD_WR_DATA(0x00FF&xStar);		
	LCD_WR_DATA(xEnd>>8);
	LCD_WR_DATA(0x00FF&xEnd);

	LCD_WR_REG(lcddev.setycmd);	
	LCD_WR_DATA(yStar>>8);
	LCD_WR_DATA(0x00FF&yStar);		
	LCD_WR_DATA(yEnd>>8);
	LCD_WR_DATA(0x00FF&yEnd);

	LCD_WriteRAM_Prepare();	//ʼдGRAM			
}   

//========================================================================
// : void LCD_SetCursor(u16 Xpos, u16 Ypos)
// : ùλ
// : xy
// : none
// ע: none
//========================================================================
void LCD_SetCursor(u16 Xpos, u16 Ypos)
{	  	    			
	LCD_SetWindows(Xpos,Ypos,Xpos,Ypos);	
} 

//========================================================================
// : void LCD_direction(u8 direction)
// : Ļ
// : 
// : none
// ע: none
//========================================================================
void LCD_direction(u8 direction)
{ 
	lcddev.setxcmd=0x2A;
	lcddev.setycmd=0x2B;
	lcddev.wramcmd=0x2C;
	lcddev.rramcmd=0x2E;
	lcddev.dir = direction%4;
	switch(lcddev.dir){		  
		case 0:						 	 		
			lcddev.width=LCD_W;
			lcddev.height=LCD_H;		
			LCD_WriteReg(0x36,(1<<3)|(1<<6));
		break;
		case 1:
			lcddev.width=LCD_H;
			lcddev.height=LCD_W;
			LCD_WriteReg(0x36,(1<<3)|(1<<5));
		break;
		case 2:						 	 		
			lcddev.width=LCD_W;
			lcddev.height=LCD_H;	
			LCD_WriteReg(0x36,(1<<3)|(1<<7));
		break;
		case 3:
			lcddev.width=LCD_H;
			lcddev.height=LCD_W;
			LCD_WriteReg(0x36,(1<<3)|(1<<7)|(1<<6)|(1<<5));
		break;	
		default:break;
	}	
}	 

//========================================================================
// : u16 LCD_Read_ID(void)
// : ȡĻID
// : none
// : ĻID
// ע: none
//========================================================================
u16 LCD_Read_ID(void)
{
	u8 i,val[3] = {0};
	LCD_WR_REG(0xF0);     // Command Set Control
	LCD_WR_DATA(0xC3);   

	LCD_WR_REG(0xF0);     
	LCD_WR_DATA(0x96);  
	LCD_CS=0;
	for(i=1;i<4;i++)
	{
		LCD_RS=0;	  
		SPI_WriteByte(0xFB);
		LCD_RS=1;
		SPI_WriteByte(0x10+i);
		LCD_RS=0;	  
		SPI_WriteByte(0xD3);
//		SPI_SetSpeed(0);
		LCD_RS=1;
		val[i-1] = SPI_WriteByte(0xFF);
//		SPI_SetSpeed(SPI1,1);
		LCD_RS=0;	  
		SPI_WriteByte(0xFB);
		LCD_RS=1;
		SPI_WriteByte(0x00);	
	}
	LCD_CS=1;
	LCD_WR_REG(0xF0);     // Command Set Control
	LCD_WR_DATA(0x3C);   
	LCD_WR_REG(0xF0);     
	LCD_WR_DATA(0x69);  
	lcddev.id=val[1];
	lcddev.id<<=8;
	lcddev.id|=val[2];
	return lcddev.id;
}